unit ucontrols;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, StdCtrls, Spin, ComCtrls,Dialogs
  ,uev3webcam;

type

  { TVControlFrame }

  TVControlFrame = class(TFrame)
    BDef: TButton;
    BMin: TButton;
    BMax: TButton;
    VCBox: TGroupBox;
    CEdit: TSpinEdit;
    CTrack: TTrackBar;
    procedure BDefClick(Sender: TObject);
    procedure BMaxClick(Sender: TObject);
    procedure BMinClick(Sender: TObject);
    procedure CEditChange(Sender: TObject);
    procedure CTrackChange(Sender: TObject);
  private
    fVControl:TUserControl;
  public
    procedure BindControl(VCName:string; VCtrl:TUserControl);
  end;

implementation

{ TVControlFrame }

procedure TVControlFrame.BDefClick(Sender: TObject);
begin
 CEdit.Value:=fVControl.def;
end;

procedure TVControlFrame.BMaxClick(Sender: TObject);
begin
  CEdit.Value:=fVControl.max;
end;

procedure TVControlFrame.BMinClick(Sender: TObject);
begin
  CEdit.Value:=fVControl.min;
end;

procedure TVControlFrame.CEditChange(Sender: TObject);
begin
  CTrack.position:=CEdit.Value;
  fVControl.value:=CEdit.Value;
end;

procedure TVControlFrame.CTrackChange(Sender: TObject);
begin
  CEdit.Value:=CTrack.position;
end;

procedure TVControlFrame.BindControl(VCName: string; VCtrl: TUserControl);
begin
  VCBox.Enabled:=false;
  VCBox.Caption:=VCName;
  if not Vctrl.valid then exit;
  fVControl:=Vctrl;
  with ctrack do begin
    min:=fVControl.min;
    max:=fVControl.max;
    position:=fVControl.value;
  end;
  with cedit do begin
    minValue:=fVControl.min;
    maxValue:=fVControl.max;
    value:=fVControl.value;
  end;
  VCBox.Enabled:=true;
end;

initialization
  {$I ucontrols.lrs}

end.

